<?php
/*
 * Phamm - http://phamm.rhx.it - <phamm@rhx.it>
 * Copyright (C) 2004-2005 Alessandro De Zorzi and Mirko Grava
 *  
 * Phamm is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Phamm is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* @package configuration
* @package application
* @author Alessandro De Zorzi <adezorzi@rhx.it>
**/

///////////////////////////////////////////////////////////////////////
// This is the main Phamm config file
// *** NOTE *** Probably you need to edit the plugin
// config files in each plugin dir
//
// example: plugins/mail/config.inc.php
///////////////////////////////////////////////////////////////////////

// LDAP Server Settings
$LDAP_SERVER	= '127.0.0.1';	// The server
define (LDAP_PORT,'389');	// The server port
$SUFFIX			= 'dc=example,dc=tld';	// The container
$admin			= 'manager';		// RootDN

// Phamm access control Settings
define (NOLOGIN,0);	// if you don't want use login system
$secret			= 'secret';	// only if nologin=1 set the Password
define (FORCE_SSL,0);	// 1 if you want force SSL

// Layout Settings
$version		= '0.2.3';
$language		= 'en_GB';
$td_width		= '200';
$td_width_box	= '100';
$title			= 'Phamm';	// The page title
define (REFRESH_TIME,1); // Seconds after refresh page

$supported_languages = array(
"en_GB" => "English",
"it_IT" => "Italiano",
// "cc" => "Your language here",
"fr_FR" => "Francais",
"de_DE" => "Deutsch",
"pt_BR" => "Brasileiro",
"hu_HU" => "Magyar"
);

// PLUGINS SETTING
define (USE_PLUGINS,0);
define (DEFAULT_PLUGIN, 'mail'); // Don't change if unsure!

// This array contains the active plugins name
$plugins = array(
"mail",
//"pdns",
"whoami"
);

// Advanced Settings - leave unchanged if unsure!
define (DEBUG,0); 		// Debug level 0 or 1
define (ERROR_LEVEL,1); 		// PHP Error Level 0,1,2,10
define (ADVANCED_VIEW,0);	// only for advanced users
define (JAMM_COMPATIBILITY,0); // *unused* Jamm COMPATIBILITY
define (PHAMM_LOG,0); 		// Log 0 or 1
define (LOG_FILE,'/tmp/phamm.log'); // File to log

?>
