<?php
/*
 * Phamm - http://phamm.rhx.it - <phamm@rhx.it>
 * Copyright (C) 2004,2005 Alessandro De Zorzi and Mirko Grava
 *
 * This file is part of Phamm.
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* @package application
* @subpackage pdns
* @author Alessandro De Zorzi <adezorzi@rhx.it>
**/

require ('./plugins/pdns/functions.php');

$info = $_POST["info"];

/*if (isset($domain))
	echo "<H1>$domain</H1>"; */

if ($domain && !isset($action))
{
    $actionCode = 1;
}

elseif ($action == 'dns_modify')
{
    $aRecord = $_POST["aRecord"];
    $nSRecord = $_POST["nSRecord"];
    $mxP = $_POST["mxP"];
    $mxA = $_POST["mxA"];
    $mxIP = $_POST["mxIP"];

    $actionCode = 2;
}

elseif ($action == 'addZone')
{
    $actionCode = 3;

}

// Logig actions
switch ($actionCode)
{
case "1" :
        dnsDomain ($domain);
    echo "<BR>";
    dnsZone ($domain);
    break;

case "2" :
    echo "<H1>Modifica...</H1>";
    dnsModify ($domain,$aRecord,$nSRecord,$mxP,$mxA,$mxIP);
    refresh("index.php"."?domain=".$domain,'',REFRESH_TIME);
    break;
	
case "3" :
	addZone ('mirko.it','zonazona','11.123.12.12',$cNAMERecord);

    break;
}


?>
