<?php
/*
 * Phamm - http://phamm.rhx.it - <phamm@rhx.it>
 * Copyright (C) 2004,2005 Alessandro De Zorzi and Mirko Grava
 *
 * This file is part of Phamm.
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* @package locale
* @author Renato Ben <renato AT civetta.net> (Translator)
**/

// Italiano
$lang['server']				= 'Server';
$lang['domain']				= 'Dominio';
$lang['domain_property']		= 'Dominio, Proprieta\'';
$lang['domains']			= 'Domini';
$lang['postmaster']			= 'Postmaster';
$lang['postmaster_password']		= 'Postmaster Password';
$lang['add_postmasters']		= 'Aggiungi Postmasters';
$lang['catch_all']			= 'Catch All';
$lang['postmasters']			= 'Postmaster';
$lang['appoint_postmasters']		= 'Nomina postmaster';
$lang['search'] 			= 'Cerca';
$lang['equals']				= 'Uguale';
$lang['starts_with']			= 'Comincia con';
$lang['contains']			= 'Contiene';
$lang['ends_with']			= 'Finisce con';
$lang['sounds_like']			= 'Si pronuncia come';
$lang['add_mail']			= 'Aggiungi mail';
$lang['email']				= 'E-mail';
$lang['add_alias']			= 'Aggiungi alias';
$lang['add_domain']			= 'Aggiungi dominio';
$lang['accounts']			= 'Account';
$lang['alias']				= 'Alias';
$lang['aliases']			= 'Alias';
$lang['edit_accounts']			= 'Modifica account';
$lang['active']				= 'Attivo';
$lang['domain_is_active']		= 'Dominio attivo';
$lang['account_is_active']		= 'Account attivo';
$lang['alias_is_active']		= 'Alias attivo';
$lang['delete']				= 'Cancella';
$lang['confirm_delete']			= 'Conferma Eliminazione';
$lang['delete_account']			= 'Cancella account';
$lang['delete_domain']			= 'Cancella dominio';
$lang['delete_alias']			= 'Cancella alias';
$lang['quota']				= 'Quota';
$lang['all']				= 'Tutti';
$lang['real_name']			= 'Nome';
$lang['return_to']			= 'Ritorna a';
$lang['username']			= 'Username';
$lang['login']				= 'Login';
$lang['login_incorrect']		= 'Login/password non corretti, riprova';
$lang['modify_mail']			= 'Modifica mail';
$lang['modify_alias']			= 'Modifica alias';
$lang['modify_mails']			= 'Modifica mails';
$lang['modify_domains']			= 'Modifica domains';
$lang['modify_aliases']			= 'Modifica aliases';
$lang['domain_is_not_valid'] 		= 'Il Dominio non e\' valido!';
$lang['mail_is_not_valid'] 		= 'Mail non valida!';
$lang['alias_is_not_valid'] 		= 'Alias non valido!';
$lang['password_dont_match']		= 'Password errata!';
$lang['password']			= 'Password';
$lang['repeat_password']		= 'Ripetere Password';
$lang['error_connection']		= 'Errore di Connessione';
$lang['destinations']			= 'Destinazioni';
$lang['add_destinations']		= 'Aggiungi Destinazioni';
$lang['delete_destinations']		= 'Cancella Destinazioni';
$lang['deleting']			= 'In cancellazione';
$lang['check_all']			= 'Seleziona tutto';
$lang['virus_check']		= 'Virus Check';
$lang['spam_check']		= 'Spam Check';
$lang['change_postmaster_password']	= 'Cambia la Password del Postmaster';
$lang['warning_postmaster_password']	= 'Attenzione!';
$lang['error_config_file']		= 'Errore. File di configurazione non trovato. Copia config.inc.php.template -> config.inc.php';
$lang['added']				= 'Added';
$lang['not_added']			= 'Not Added';
$lang['domain_modify']		= 'Modify Domain';
$lang['modify']				= 'Modify';
$lang['vacation']			= 'Vacation';
$lang["vacation_description"] = 'Vacation Description'; // ADDED
$lang["vacation_forward"]	= 'Vacation Forward';
$lang["vacation_info"]		= 'Vacation Info';
$lang["vacation_start"]		= 'Vacation Start';
$lang["vacation_end"]		= 'Vacation End';
$lang["check_to_activate"]	= 'Check to Activate';
$lang["check_to_deactivate"]= 'Check to Deactivate';
$lang["spamtaglevel"]		= 'Spam Tag Level';
$lang["spamtag2level"]		= 'Spam Tag2 Level';
$lang["spamkilllevel"]		= 'Spam Kill Level';
$lang["min"]			= 'Min';
$lang["max"]			= 'Max';
$lang["spam_control"]		= 'Spam Control';
$lang["low"]			= 'Low';
$lang["medium"]			= 'Medium';
$lang["high"]			= 'High';
$lang["very_high"]		= 'Very High';
$lang["return_to_domain"]	= 'Return to domain';

?>
