<?php
/*
 * Phamm - http://phamm.rhx.it - <phamm@rhx.it>
 * Copyright (C) 2004 Alessandro De Zorzi and Mirko Grava
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* Add a domain
* 
* @package functions
* @author Alessandro De Zorzi <adezorzi@rhx.it>
* 
* @var string domain_new
* @var string password
* @return bolean the result success=1 or insuccess=0
**/

function add_domain ($domain_new, $password)
{
    global $connect;
    global $LDAP_BASE;
    global $SUFFIX;
    global $editAccounts;
    global $editPostmasters;
    global $accountActive;

    // prepare data
    $info["objectclass"][0]		= "top";
    $info["objectclass"][1]		= "JammVirtualDomain";
    $info["jvd"]			= "$domain_new";
    $info["postfixTransport"]	= "virtual:";
    $info["editAccounts"]		= "$editAccounts";
    $info["editPostmasters"]	= "$editPostmasters";
 //   $info["editAliases"]		= "$editAliases";
    $info["accountActive"]		= "$accountActive";
    $info["lastChange"]			= time();
    $info["delete"]				= "FALSE";

    $r=ldap_add($connect, "jvd=$domain_new,$LDAP_BASE", $info);

	if (DEBUG)
	{
		echo  "jvd=$domain_new,$LDAP_BASE <BR>";
		echo var_dump ($info);
	}

	return $r;
}
?>
